#!/usr/bin/env python
# -*- Python -*-


import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM_aist
import RTC

import codecs






# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
GuiController_spec = ["implementation_id", "Trans", 
		 "type_name",         "Trans", 
		 "description",       "Trans Component", 
		 "version",           "0.1", 
		 "vendor",            "Miyamoto Nobuhiko", 
		 "category",          "TEST", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

class GuiController(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
                
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_Out = RTC.TimedFloatSeq(RTC.Time(0,0),[])
		self._OutOut = OpenRTM_aist.OutPort("FloatOut", self._d_Out, OpenRTM_aist.RingBuffer(8))
		
		# Set OutPort buffers
		self.registerOutPort("FloatOut",self._OutOut)

		self._d_In = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._InIn = OpenRTM_aist.InPort("DoubleIn", self._d_In, OpenRTM_aist.RingBuffer(8))
		
		# Set OutPort buffers
		self.registerInPort("DoubleIn",self._InIn)




		

		

		

		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		

		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	def onInitialize(self):
            
		# Bind variables and configuration variable
		
		return RTC.RTC_OK


	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OKvdef onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onActivated(self, ec_id):
	#
        #       return RTC.RTC_OK
	
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onExecute(self, ec_id):
                if self._InIn.isNew():
                        inport = self._InIn.read()
                        self._d_Out.data = inport.data
                        self._OutOut.write()
            
            
            
                return RTC.RTC_OK

	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	



#def MyModuleInit(manager):
#    profile = OpenRTM_aist.Properties(defaults_str=GuiController_spec)
#    manager.registerFactory(profile,
#                           GuiController,
#                            OpenRTM_aist.Delete)

    # Create a component
#    comp = manager.createComponent("GuiController")



def main():
        
	mgr = OpenRTM_aist.Manager.init(len(sys.argv), sys.argv)
	mgr.activateManager()
	
	profile = OpenRTM_aist.Properties(defaults_str=GuiController_spec)
        mgr.registerFactory(profile,
                            GuiController,
                            OpenRTM_aist.Delete)

        # Create a component
        comp = mgr.createComponent("Trans")
        
	mgr.runManager()

if __name__ == "__main__":
	main()

